	var DEBUG = false;
    var useSubmit = false;
    var useNumberShortcuts = true;
    var useContextMenu = true;
    var useSmartNext = false;
	var NEXTPLEASE_MAX_LINK_NUM = 700;
	var NEXTPLEASE_MAX_GALLERY_GAP = 20;
	var NEXTPLEASE_MAX_IMAGE_CACHE = 500;

    var nextKeyString;
    var prevKeyString;
    var firstKeyString;
    var lastKeyString;

    var modifierString;
    var nextModifierString;
    var prevModifierString;
    var firstModifierString;
    var lastModifierString;

    var nextRegExString;
    var prevRegExString;
    var firstRegExString;
    var lastRegExString;
    var galleryRegExString;

    var isNextRegExp;
    var isPrevRegExp;
    var isFirstRegExp;
    var isLastRegExp;

    var NextPhrasesMap = new Array();
    var PrevPhrasesMap = new Array();
    var FirstPhrasesMap = new Array();
    var LastPhrasesMap = new Array();

    var NextImagesMap = new Array();
    var PrevImagesMap = new Array();
    var FirstImagesMap = new Array();
    var LastImagesMap = new Array();

    var KeyCodeToNameMap = new Array();

    var DefaultNextPhrases = new Array("Next", "next", "Next >", "next >", ">", "MORE RESULTS", "Newer ", "Older topics ", "next page", "Go to the next photo in the stream");  
    var DefaultPrevPhrases = new Array("Previous", "previous", "Prev", "prev", "< Previous", "< previous", 
				       "PREVIOUS RESULTS", "< Prev", "< prev", "<", "<< Prev", " Older", " Newer topics", "previous page", "Go to the previous photo in the stream");
    var DefaultFirstPhrases = new Array("First", "first", "< First", "< first", "first page", " first");
    var DefaultLastPhrases = new Array("Last", "last", "Last >", "last >", "last page", "last ");

    
    var DefaultNextImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-more-results.gif");
    var DefaultPrevImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-previous.gif");
    var DefaultFirstImages = new Array();
    var DefaultLastImages = new Array();


	var nextplease_imageLocationMap = new Object();
	var nextplease_imageLocationArray = new Array();

    // changed «chevrons» to \\xab and \\xbb - v1.31
    var DefaultNextRegEx  = "^next(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*\$";
    var DefaultPrevRegEx  = "^((<?<?)|\\xab)\\s*((prev(ious)?(\\s+\\d+)?(\\s+\\w+)?)|back)\\s*\$";
    var DefaultFirstRegEx = "^((<?<?)|\\xab)\\s*(first(\\s+\\d+)?(\\s+\\w+)?)\\s*$";
    var DefaultLastRegEx  = "^last(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*$";

//    var DefaultNextRegEx  = "^next(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)||\\xbb)\\s*\$";
//    var DefaultPrevRegEx  = "^((<?<?)||\\xab)\\s*((prev(ious)?(\\s+\\d+)?(\\s+\\w+)?)|back)\\s*\$";
//    var DefaultFirstRegEx = "^((<?<?)||\\xab)\\s*(first(\\s+\\d+)?(\\s+\\w+)?)\\s*$";
//    var DefaultLastRegEx  = "^last(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)||\\xbb)\\s*$";

    var OldDefaultGalleryRegEx  = ".*?(\\d+)[^/]*?\\.(?:jpg|gif|bmp|png)$";
	var DefaultGalleryRegEx  = "(.*(?:[^\\d]|^))(\\d+)([^/]*?\\.(?:jpg|gif|bmp|png))$";

	// TODO: How to handle upgrades? Do a check on a test url, and if

    const NEXT_SEARCH_TYPE = 1;
    const PREV_SEARCH_TYPE = 2;
    const FIRST_SEARCH_TYPE = 3;
    const LAST_SEARCH_TYPE = 4;

// This code was stolen from brody on the mozillazine.org forums.
var nextpleaseLoadListener = { 

    dumpToConsole: false, 
    enableAlerts: false, 

    fireBeforeImagesLoaded: true,
    topLevelDocumentsOnly: true, 

    onLoad: function(event) { 
        this.consoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService); 
        this.promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService); 

        if(this.fireBeforeImagesLoaded) this.loadType = "DOMContentLoaded"; 
        else this.loadType = "load"; 

        gBrowser.addEventListener(this.loadType,function(event) { nextpleaseLoadListener.onContentLoaded(event); },true); 
    }, 

    onContentLoaded: function(event) { 
        var doc = event.originalTarget; 

        // Only for top level documents and not subframes? 
        if(this.topLevelDocumentsOnly) { 
            // When this becomes true it means that 
            // all of the top level document's 
            // subframes have also finished loading 
            if(!this.isTopLevelDocument(doc)) return; 
        } 

        // Log/alert 
        var eol = this.getEol(); 
        var message = this.loadType + eol + doc.title + eol + doc.documentURI; 
        if(this.dumpToConsole) { 
            this.consoleService.logStringMessage("nextpleaseLoadListener" + eol + message); 
        } 
        if(this.enableAlerts) { 
            this.promptService.alert(window,"nextpleaseLoadListener",message); 
        } 
		nextplease_cacheImageLocations();

        // Get the browser for the document (if required) 
        var browser = this.getBrowserForDocument(doc); 
        if(!browser) return; 

        // If you have enabled topLevelDocuments only and 
        // want to get all documents contained in the browser 
        // for processing, do it like so 
        var documents = this.getDocuments(browser.contentWindow,new Array()); 
    }, 

    isTopLevelDocument: function(aDocument) { 
        var browsers = gBrowser.browsers; 
        for(var i = 0; i < browsers.length; i++) { 
            if(aDocument == browsers[i].contentDocument) return true; 
        } 
        return false; 
    }, 

    getDocuments: function(aFrame,aArray) { 
        const frames = aFrame.frames; 
        aArray.push(aFrame.document); 
        for(var i = 0; i < frames.length; i++) this.getDocuments(frames[i],aArray); 
        return aArray; 
    }, 

    getBrowserForDocument: function(aDocument) { 
        // This function can return the browser for not only top level documents 
        // but also documents contained in subframes 

        // If the document is top level then return its browser here 
        var browsers = gBrowser.browsers; 
        for(var i = 0; i < browsers.length; i++) { 
            if(aDocument == browsers[i].contentDocument) return browsers[i]; 
        } 

        // Else it must be in a subframe, so check all frames in each browser 
        // to find the parent browser 
        var documents; 
        for(var j = 0; j < browsers.length; j++) { 
            documents = this.getDocuments(browsers[j].contentWindow,new Array()); 
            for(var k = 0; k < documents.length; k++) { 
                if(aDocument == documents[k]) return browsers[j]; 
            } 
        } 

        // Else the browser could not be determined 
        return null; 
    }, 

    getPlatform: function() { 
        var platform = navigator.platform.toLowerCase(); 
        if(platform.indexOf('win') != -1) return 'win'; // win 
        else if(platform.indexOf('mac') != -1) return 'mac'; // mac 
        else return 'other'; // other (nix) 
    }, 
    getEol: function() { 
        switch(this.getPlatform()) { 
            case 'win': return '\r\n'; 
            case 'mac': return '\r'; 
            case 'other': return '\n'; 
            default: return '<eol>'; 
        } 
    } 
}; 


// Strip leading and trailing whitespace from
// the passed in string and return it.
function nextplease_Trim(str) {
    return str.replace(/^\s*|\s*$/g,"");
}


function nextplease_SetUnicharPref(prefs, aPrefName, aPrefValue)
{
   if (prefs)
   {
     try {
       var str = Components.classes["@mozilla.org/supports-string;1"].createInstance(Components.interfaces.nsISupportsString);
       str.data = aPrefValue;
       prefs.setComplexValue(aPrefName, Components.interfaces.nsISupportsString, str);
     }
     catch(e) {}
   }
}

function nextplease_GetUnicharPref(prefs, aPrefName)
{
  if (prefs)
  {
    try {
      return prefs.getComplexValue(aPrefName, Components.interfaces.nsISupportsString).data;
    }
    catch(e) {}
  }
  return "";
}

// Initialize the lookup table for keycode to keyname
function nextplease_initializeKeyCodeToStringMap(map)
{
    map[KeyEvent.DOM_VK_LEFT] = "VK_LEFT";
    map[KeyEvent.DOM_VK_RIGHT] = "VK_RIGHT";
    map[KeyEvent.DOM_VK_UP] = "VK_UP";
    map[KeyEvent.DOM_VK_DOWN] = "VK_DOWN";
    map[KeyEvent.DOM_VK_PAGE_UP] = "VK_PAGE_UP";
    map[KeyEvent.DOM_VK_PAGE_DOWN] = "VK_PAGE_DOWN";
    map[KeyEvent.DOM_VK_HOME] = "VK_HOME";
    map[KeyEvent.DOM_VK_END] = "VK_END";
    map[KeyEvent.DOM_VK_F1] = "VK_F1";
    map[KeyEvent.DOM_VK_F2] = "VK_F2";
    map[KeyEvent.DOM_VK_F3] = "VK_F3";
    map[KeyEvent.DOM_VK_F4] = "VK_F4";
    map[KeyEvent.DOM_VK_F5] = "VK_F5";
    map[KeyEvent.DOM_VK_F6] = "VK_F6";
    map[KeyEvent.DOM_VK_F7] = "VK_F7";
    map[KeyEvent.DOM_VK_F8] = "VK_F8";
    map[KeyEvent.DOM_VK_F9] = "VK_F9";
    map[KeyEvent.DOM_VK_F10] = "VK_F10";
    map[KeyEvent.DOM_VK_F11] = "VK_F11";
    map[KeyEvent.DOM_VK_F12] = "VK_F12";
}

// Read the phrases that specify a next link
// by reading the preferences or defaults,
// and put the phrases in a lookup table.
function nextplease_initializeNextPrevMap(prefbranch, DefaultArray) {
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var Map = new Array();
    if (nextpleasePrefs.prefHasUserValue(prefbranch + '.expr0')) {
	var tempprefname = prefbranch + '.expr0';
	var i=0;
	while (nextpleasePrefs.prefHasUserValue(tempprefname)) {
	    //	    var phrase = nextpleasePrefs.getCharPref(tempprefname);
	    var prefValue = nextplease_GetUnicharPref(nextpleasePrefs, tempprefname, Components.interfaces.nsISupportsString);
	    var values = prefValue.split("|");
	    for (var j=0; j<values.length; j++) 
		{
		    var phrase = values[j].replace(/&pipe;/g, "|");
		    if (phrase != '') {
			Map[phrase] = true;
		    }
		}
	    i++;
	    tempprefname = prefbranch + '.expr'+i;
	}
    } else {
	for (var i=0; i<DefaultArray.length; i++) {
	    Map[DefaultArray[i]] = true;
	}
    }
    return Map;
}

function nextplease_init() {
    nextplease_initializeKeyCodeToStringMap(KeyCodeToNameMap);
    nextplease_readPreferences();
}

function nextplease_cacheImageLocations() {

    if (DEBUG) { 
		nextpleaseLoadListener.consoleService.logStringMessage("nextpleaseLoadListener "); 
	}
	var start = new Date();
    var imgElems = window._content.document.getElementsByTagName("img");
	var end = new Date();
    if(DEBUG) { 
		nextpleaseLoadListener.consoleService.logStringMessage("nextpleaseLoadListener " + (end.getTime() - start.getTime())); 
	}

	start = new Date();
    if (imgElems) {
		for (var i=0; i<imgElems.length; i++) {
			if (!(nextplease_imageLocationMap[imgElems[i].src] >= 0)) {
				if (nextplease_imageLocationArray.length >= NEXTPLEASE_MAX_IMAGE_CACHE) {
					var deletedVal = nextplease_imageLocationArray.shift();
					// alert(deletedVal);
					delete nextplease_imageLocationMap[deletedVal];
				}

				nextplease_imageLocationMap[imgElems[i].src] = nextplease_imageLocationArray.length;
				nextplease_imageLocationArray[nextplease_imageLocationArray.length] = imgElems[i].src;
			}
		}
	}
	 end = new Date();
    if(DEBUG) { 
		nextpleaseLoadListener.consoleService.logStringMessage("nextpleaseLoadListener took " + (end.getTime() - start.getTime()) + " ms... num imgs = " + imgElems.length); 
	}

	start = new Date();
    var links = window._content.document.getElementsByTagName("a");
    if (links) {
		for (var i=0; i<links.length; i++) {
			var linkUrl = links[i].href;
			if (!(nextplease_imageLocationMap[linkUrl] >= 0)) {
				if (linkUrl.length > 3) {
					var suffixIndex = linkUrl.length - 3;
					var suffix = linkUrl.substr(suffixIndex).toLowerCase();	

					// This is technically not correct, but performance sucks
					// if we do a proper regex check.
					if ((suffix == 'jpg') || 
						(suffix == 'gif') ||
						(suffix == 'png') ||
						(suffix == 'bmp')) {
						if (nextplease_imageLocationArray.length >= NEXTPLEASE_MAX_IMAGE_CACHE) {
							var deletedVal = nextplease_imageLocationArray.shift();
							// alert(deletedVal);
							delete nextplease_imageLocationMap[deletedVal];
						}
						nextplease_imageLocationMap[linkUrl] = nextplease_imageLocationArray.length;
						nextplease_imageLocationArray[nextplease_imageLocationArray.length] = linkUrl;
					}
				}
			}
		}
	}
	end = new Date();
    if(DEBUG) { 
		nextpleaseLoadListener.consoleService.logStringMessage("nextpleaseLoadListener took " + (end.getTime() - start.getTime()) + " ms... num links = " + links.length); 
	}

//	alert(nextplease_imageLocationArray);

}

function nextplease_initModifierString(prefs, prefname) {
    var modString;
    if (prefs.prefHasUserValue(prefname)) 
	modString = prefs.getCharPref(prefname);
    else {
	// Special case check for setting prev modifier for upgraders
	// for version 0.5.x and earlier
	if ((prefname == 'nextplease.prevkeymodifier') &&
	    (prefs.prefHasUserValue('nextplease.keymodifier'))) {
	    modString = prefs.getCharPref('nextplease.keymodifier');
	} else {
	    modString = 'ctrl+shift';
	}
    }
    
    modString = modString.toLowerCase().replace(/\+/g," ");
    modString = modString.toLowerCase().replace(/ctrl/g,"accel");

    return modString;
}

function nextplease_initKey (prefs, prefname, keyId, defaultKeyCode, modString) {
    var keyCode;
    var keyString;
    if (prefs.prefHasUserValue(prefname)) 
	keyCode = prefs.getIntPref(prefname);
    else 
	keyCode = defaultKeyCode;

    var keyElem = document.getElementById(keyId);
    keyElem.setAttribute("modifiers", modString);
    
    if (KeyCodeToNameMap[keyCode]) {
    	keyString = KeyCodeToNameMap[keyCode];
	keyElem.removeAttribute("key");
    	keyElem.setAttribute("keycode", keyString);
    } else {
	keyString = String.fromCharCode(keyCode).toUpperCase();
    	keyElem.setAttribute("key", keyString);
    	keyElem.removeAttribute("keycode");
    }
    return keyString;
}


// Read the preferences and setup the 
// useCtrl/useShift/useAlt vars and next/prev
// phrase and image lookup tables
function nextplease_readPreferences() {

    var isAlphaNumeric = /^\w$/;

    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    modifierString = nextplease_initModifierString(nextpleasePrefs, 'nextplease.keymodifier');

    nextModifierString  = nextplease_initModifierString(nextpleasePrefs, 'nextplease.keymodifier');;
    prevModifierString  = nextplease_initModifierString(nextpleasePrefs, 'nextplease.prevkeymodifier');;
    firstModifierString = nextplease_initModifierString(nextpleasePrefs, 'nextplease.firstkeymodifier');;
    lastModifierString  = nextplease_initModifierString(nextpleasePrefs, 'nextplease.lastkeymodifier');;


    var nextKeyCode;
    var prevKeyCode;
	
    nextKeyString = nextplease_initKey (nextpleasePrefs, 'nextplease.nextkey',
					'nextpleasekey', KeyEvent.DOM_VK_RIGHT,
					nextModifierString);
    prevKeyString = nextplease_initKey (nextpleasePrefs, 'nextplease.prevkey',
					'nextpleaseprevkey', KeyEvent.DOM_VK_LEFT,
					prevModifierString);
    firstKeyString = nextplease_initKey (nextpleasePrefs, 'nextplease.firstkey',
					'nextpleasefirstkey', KeyEvent.DOM_VK_UP,
					firstModifierString);
    lastKeyString = nextplease_initKey (nextpleasePrefs, 'nextplease.lastkey',
					'nextpleaselastkey', KeyEvent.DOM_VK_DOWN,
					lastModifierString);


    if (nextpleasePrefs.prefHasUserValue('nextplease.allowsubmit'))
	useSubmit = nextpleasePrefs.getBoolPref('nextplease.allowsubmit');

    if (nextpleasePrefs.prefHasUserValue('nextplease.allownumbershortcuts'))
	useNumberShortcuts = nextpleasePrefs.getBoolPref('nextplease.allownumbershortcuts');

    if (nextpleasePrefs.prefHasUserValue('nextplease.allowcontextmenu')) 
	useContextMenu = nextpleasePrefs.getBoolPref('nextplease.allowcontextmenu');

    if (nextpleasePrefs.prefHasUserValue('nextplease.allowsmartnext')) 
	useSmartNext = nextpleasePrefs.getBoolPref('nextplease.allowsmartnext');

    var numberkey;
    for (var i=1; i<10; i++) {
	numberkey = document.getElementById("nextplease" + i + "key");
	numberkey.setAttribute("disabled", !useNumberShortcuts);
    }

    nextRegExString = DefaultNextRegEx;
    if (nextpleasePrefs.prefHasUserValue('nextplease.nextregex')) 
	nextRegExString = nextplease_GetUnicharPref(nextpleasePrefs, 
						    'nextplease.nextregex');

    if (nextplease_Trim(nextRegExString) == '')
        nextRegExString = DefaultNextRegEx;

    isNextRegExp = new RegExp(nextRegExString, "i");

    prevRegExString = DefaultPrevRegEx;
    if (nextpleasePrefs.prefHasUserValue('nextplease.prevregex')) 
	prevRegExString = nextplease_GetUnicharPref(nextpleasePrefs, 
						    'nextplease.prevregex');
    if (nextplease_Trim(prevRegExString) == '')
        prevRegExString = DefaultPrevRegEx;

    isPrevRegExp = new RegExp(prevRegExString, "i");

    firstRegExString = DefaultFirstRegEx;
    if (nextpleasePrefs.prefHasUserValue('nextplease.firstregex')) 
	firstRegExString = nextplease_GetUnicharPref(nextpleasePrefs, 
						    'nextplease.firstregex');
    if (nextplease_Trim(firstRegExString) == '')
        firstRegExString = DefaultFirstRegEx;
    isFirstRegExp = new RegExp(firstRegExString, "i");

    lastRegExString = DefaultLastRegEx;
    if (nextpleasePrefs.prefHasUserValue('nextplease.lastregex')) 
	lastRegExString = nextplease_GetUnicharPref(nextpleasePrefs, 
						    'nextplease.lastregex');
    if (nextplease_Trim(lastRegExString) == '')
        lastRegExString = DefaultLastRegEx;

    isLastRegExp = new RegExp(lastRegExString, "i");

    galleryRegExString = DefaultGalleryRegEx;
    if (nextpleasePrefs.prefHasUserValue('nextplease.galleryregex')) {
		galleryRegExString = nextplease_GetUnicharPref(nextpleasePrefs, 
							    'nextplease.galleryregex');
	    if (nextplease_Trim(galleryRegExString) == '')
	        galleryRegExString = DefaultGalleryRegEx;
	    var galleryUrlRegex = new RegExp(galleryRegExString, "i");
	    var matches = galleryUrlRegex.exec('http://nextplease.mozdev.org/test/test101.jpg');
	    if (matches && (matches.length != 4)) {
	        galleryRegExString = DefaultGalleryRegEx;
		}
	}

    nextplease_DisableConflictingKeys();

    NextPhrasesMap = nextplease_initializeNextPrevMap('nextplease.nextphrase', DefaultNextPhrases);
    PrevPhrasesMap = nextplease_initializeNextPrevMap('nextplease.prevphrase', DefaultPrevPhrases);
    FirstPhrasesMap = nextplease_initializeNextPrevMap('nextplease.firstphrase', DefaultFirstPhrases);
    LastPhrasesMap = nextplease_initializeNextPrevMap('nextplease.lastphrase', DefaultLastPhrases);

    NextImagesMap  = nextplease_initializeNextPrevMap('nextplease.nextimage', DefaultNextImages);
    PrevImagesMap  = nextplease_initializeNextPrevMap('nextplease.previmage', DefaultPrevImages);
    FirstImagesMap  = nextplease_initializeNextPrevMap('nextplease.firstimage', DefaultFirstImages);
    LastImagesMap  = nextplease_initializeNextPrevMap('nextplease.lastimage', DefaultLastImages);
}

function nextplease_DisableKey (modifier, key, keycode) {
    var conflictingKeys;
    if (key != '')
	conflictingKeys = document.getElementsByAttribute("key", key);
    else if (keycode != '') 
	conflictingKeys = document.getElementsByAttribute("keycode", keycode);

    for (var i=0; i<conflictingKeys.length; i++) {
	if (!( /nextplease/.test(conflictingKeys[i].getAttribute("id")) )
	    && conflictingKeys[i].hasAttribute("modifiers")) {
	    
	    var conflictingModifier = conflictingKeys[i].getAttribute("modifiers");
	    if ((/alt/.test(modifier) == 
	         /alt/.test(conflictingModifier)) &&
                (/shift/.test(modifier) == 
	         /shift/.test(conflictingModifier)) &&
                (/accel/.test(modifier) ==
 		 /accel/.test(conflictingModifier))) {
		    conflictingKeys[i].parentNode.removeChild(conflictingKeys[i]);
	    }
	}
    }
}

function nextplease_DisableConflictingKeys () {
    // disables any conflicting key-bindings
    var conflictingKeys;

    // Check for ALT+1/2/3... key bindings
    for (var i=1; i<10; i++) {
	nextplease_DisableKey("alt", "" + i, "");
    }

    // If it starts with VK_, then use the keycode instead of key
    if (nextKeyString.indexOf("VK_") >= 0) 
	nextplease_DisableKey(nextModifierString, "", nextKeyString);
    else
	nextplease_DisableKey(nextModifierString, nextKeyString.toLowerCase(), "");

    if (prevKeyString.indexOf("VK_") >= 0) 
	nextplease_DisableKey(prevModifierString, "", prevKeyString);
    else
	nextplease_DisableKey(prevModifierString, prevKeyString.toLowerCase(), "");

    if (firstKeyString.indexOf("VK_") >= 0) 
	nextplease_DisableKey(firstModifierString, "", firstKeyString);
    else
	nextplease_DisableKey(firstModifierString, firstKeyString.toLowerCase(), "");

    if (lastKeyString.indexOf("VK_") >= 0) 
	nextplease_DisableKey(lastModifierString, "", lastKeyString);
    else
	nextplease_DisableKey(lastModifierString, lastKeyString.toLowerCase(), "");
}


// Looks through all the links on the page
// and tries to look for one whose text matches
// one of the phrases or images. If so, it goes to/
// the corresponding link. 
// pages with frames.
function nextplease_getLink(curWindow, phraseMap, imageMap, phraseRegEx, searchType)
{
    var text;
    var isInt = /^\s*\[?\s*(\d+)\s*\]?\s*$/;
    var useFrames = true;

    var tmpPageNumLink = null;
    var firstPageNumLink = null;
    var firstPageNum;
    var lastPageNumLink = null;
    var nextPageNumLink = null;
    var prevPageNumLink = null;
    
    var currentPageNum = 100000; // Init to arbitrarily large num
    var tmpPageNum = 100000;// Init to arbitrarily large num
    var isFirstNumber = true;
    var greatestNum = 1;
    
    nextplease_readPreferences();

    var range = document.createRange();

    if (useSmartNext) {
    	if ((searchType == NEXT_SEARCH_TYPE) &&
    	    (getBrowser().canGoForward)) {
    	    return curWindow.history.forward();
    	} else if ((searchType == PREV_SEARCH_TYPE) &&
    		   (getBrowser().canGoBack)) {
    	    return curWindow.history.back();
    	}
    }
           
    // Look for <LINK> tags
    var linktags = curWindow.document.getElementsByTagName("link");

    for (var i=0; i<linktags.length; i++) {
	var link = linktags[i];
	
	// Look for rel attributes for next/prev/first/last
	if (link.rel) {
	    // Hack to workaround PHPBB's incorrect use of LINK tags.
	    if (curWindow.location.href.match("viewtopic.php")) {
		// do nothing
	    } else if ((searchType == NEXT_SEARCH_TYPE) &&
		(link.rel.toLowerCase() == "next")) { 
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == PREV_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "prev") ||
			(link.rel.toLowerCase() == "previous"))) {
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == FIRST_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "start") ||
			(link.rel.toLowerCase() == "first"))) {
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == LAST_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "end") ||
			(link.rel.toLowerCase() == "last"))) {
		return nextplease_openLink(curWindow, link);
	    }
	}
    }

    // Look for <A HREF="..."> tags
    var alinks = curWindow.document.links;

    // Search through each link
    for(var i = 0; i < alinks.length; i++) {
	var link = alinks[i];
	// Look for rel attributes for next/prev/first/last
	if (link.rel) {
	    if ((searchType == NEXT_SEARCH_TYPE) &&
		(link.rel.toLowerCase() == "next")) { 
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == PREV_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "prev") ||
			(link.rel.toLowerCase() == "previous"))) {
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == FIRST_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "start") ||
			(link.rel.toLowerCase() == "first"))) {
		return nextplease_openLink(curWindow, link);
	    } else if ((searchType == LAST_SEARCH_TYPE) &&
		       ((link.rel.toLowerCase() == "end") ||
			(link.rel.toLowerCase() == "last"))) {
		return nextplease_openLink(curWindow, link);
	    }
	}
	range.selectNode(link);
	text = nextplease_Trim(range.toString());

	// If the text is in the lookup table,
	// go to the URL
	if (phraseMap[text] == true) {
	    // alert('found phrase match');
	    if (link.href.indexOf("/dictionary") < 0) {
		return nextplease_openLink(curWindow, link);
	    }
	} else {
	    // If we don't have an exact match, 
	    // try a regular expression test.
	    // alert(text);
	    if (phraseRegEx.test(text)) {
		if (link.href.indexOf("/dictionary") < 0) {
		    return nextplease_openLink(curWindow, link);
		}
	    } else if (link.title) {
		if (phraseRegEx.test(link.title)) {
		    return nextplease_openLink(curWindow, link);
		}
	    }
	    
	    // See if there's an image tag
	    var imgElems = link.getElementsByTagName("img");
	    if (imgElems.length > 0) {
		// If the image matches, go to the URL.
		//alert(imgElems[0].src);
		var imgtext = imgElems[0].alt;
		if (!imgtext)
		    imgtext = imgElems[0].title;

		if ((imageMap[imgElems[0].src]) ||
		    (phraseMap[imgtext] == true) ||
		    (phraseRegEx.test(imgtext))) {
		    //  alert('found image match');	
		    return nextplease_openLink(curWindow, link);
		}
	    }
	}

	var intMatches = isInt.exec(text);
	if (intMatches) {
	    var linkPageNum = parseInt(intMatches[1]);
	    // If the number is greater than a NEXTPLEASE_MAX_LINK_NUM
	    // it probably doesn't have anything to do with
	    // a next/prev link.
	    // 	    alert(linkPageNum);
	    if (linkPageNum < NEXTPLEASE_MAX_LINK_NUM) {
		
		// Try to figure out what the current page and
		// next/prev links are for pages that just have
		// numbered links like  1 2 x 4 5. 

		//		if (linkPageNum == 1) {

		// We're seeing a number link that is smaller
		// than a previous one so assume that we're
		// starting a new set of number links, and
		// count from the beginning.
		if (linkPageNum <= tmpPageNum) {
		    //		    alert(linkPageNum);
		    //		    alert(currentPageNum);
		    firstPageNumLink = link;
		    firstPageNum = linkPageNum;
		    greatestNum = linkPageNum;

		    prevPageNumLink = null;
		    nextPageNumLink = null;
		    lastPageNumLink = null;
		    currentPageNum = linkPageNum; 

		    firstPageNumLink = link;
		    greatestNum = linkPageNum;
		    lastPageNumLink = null;
		    //		} else if (currentPageNum == linkPageNum) {
		    //		    currentPageNum++;
		    //		    prevPageNumLink = link;
		} else if (tmpPageNum + 1 == linkPageNum) {
		    lastPageNumLink = link;
		} else if (tmpPageNum + 2 == linkPageNum) {
		    prevPageNumLink = tmpPageNumLink;
		    nextPageNumLink = link;
		    lastPageNumLink = link;
		}

		tmpPageNum = linkPageNum;
		tmpPageNumLink = link;
	    }
	}
    }



    // next and prev are null so that means
    // we have a solid block of number 3,4,5,6,...
    if ((nextPageNumLink == null) &&
	(prevPageNumLink == null)) {

	// If we start with 1, we're probably on last page.
	// Set prev to be lastPage	
	if (firstPageNum == 1) {
		prevPageNumLink = lastPageNumLink;
		lastPageNumLink = null;
	}
	// If we start with 2, we're probably on first page.
	// Set next to be first page
	if (firstPageNum == 2) {
		nextPageNumLink = firstPageNumLink;
		firstPageNumLink = null;
	}
	if (firstPageNum > 2) {
		nextPageNumLink = firstPageNumLink;
		prevPageNumLink = lastPageNumLink;
	}
    }

    if (firstPageNumLink && lastPageNumLink &&
	(firstPageNumLink.text == lastPageNumLink.text)) 
	firstPageNumLink = null;

    //    alert(firstPageNumLink);
    //    alert(prevPageNumLink);
    //    alert(nextPageNumLink);
    //    alert(lastPageNumLink);

    // Try to find a match using our number algorithm
    if ((searchType == NEXT_SEARCH_TYPE) && nextPageNumLink)
	return nextplease_openLink(curWindow, nextPageNumLink);
    else if ((searchType == PREV_SEARCH_TYPE) && prevPageNumLink)
	return nextplease_openLink(curWindow, prevPageNumLink);
    else if ((searchType == FIRST_SEARCH_TYPE) && firstPageNumLink)
	return nextplease_openLink(curWindow, firstPageNumLink);
    else if ((searchType == LAST_SEARCH_TYPE) && lastPageNumLink)
	return nextplease_openLink(curWindow, lastPageNumLink);
    
    // Otherwise try looking for next/prev submit buttons 
    // if the user allows it.
    if (useSubmit && nextplease_getForm(phraseMap, phraseRegEx))
	return true;

    // See if we can increment the URL to get to next/prev/first
    var galleryLink = nextplease_getGalleryNumberLink(curWindow, searchType);
//	alert(galleryLink);
//	alert(nextplease_imageLocationArray.length);
	if (galleryLink) 
		curWindow.open(galleryLink, "_self", "");


    // None of it worked, so make a recursive call to
    // nextplease_getLink on the frame windows.
    var frames = curWindow.frames;
    for (var j=0; j<frames.length; j++) {
	if (nextplease_getLink(frames[j], phraseMap, imageMap, phraseRegEx, searchType))
	    return true;
    }
    return false;
}

function nextplease_getGalleryNumberLink(curWindow, searchType) 
{
    var galleryUrlRegex = new RegExp(galleryRegExString, "i");
//	alert(nextplease_imageLocationArray);

    var matches = galleryUrlRegex.exec(unescape(curWindow.location.href));
    if (matches && (matches.length == 4)) {
	var prefixUrl = matches[1];
	var suffixUrl = matches[3];
	if (searchType == NEXT_SEARCH_TYPE) {
		var curNumber = parseInt(matches[2], 10);
		for (var i=1; i<NEXTPLEASE_MAX_GALLERY_GAP; i++) {
			var urlNumber = curNumber + i;
			var padStr = nextplease_padNumber(matches[2],urlNumber);
			var linkUrl = prefixUrl + padStr + suffixUrl;
			if (nextplease_imageLocationMap[linkUrl] >= 0) {
				return linkUrl;
			}
		}
		var urlNumber = curNumber + 1;
		var padStr = nextplease_padNumber(matches[2],urlNumber);
		var linkUrl = prefixUrl + padStr + suffixUrl;
		return linkUrl;
	} else if (searchType == PREV_SEARCH_TYPE) {
		var curNumber = parseInt(matches[2], 10);
		for (var i=1; (i<NEXTPLEASE_MAX_GALLERY_GAP) && (curNumber-i >= 0); i++) {
			var urlNumber = curNumber-i;
			var padStr = nextplease_padNumber(matches[2],urlNumber);
			var linkUrl = prefixUrl + padStr + suffixUrl;
			if (nextplease_imageLocationMap[linkUrl] >= 0) {
				return linkUrl;
			}
		}

		var urlNumber = curNumber - 1;
		if (urlNumber >= 0) {
			var padStr = nextplease_padNumber(matches[2],urlNumber);
			var linkUrl = prefixUrl + padStr + suffixUrl;
			return linkUrl;
		}
	} else if (searchType == FIRST_SEARCH_TYPE) {
		var urlNumber = 1;
		var padStr = nextplease_padNumber(matches[2],urlNumber);
		var linkUrl = prefixUrl + padStr + suffixUrl;
		return linkUrl;
	}
    }
    return;
}

function nextplease_padNumber(origNumString, newNum) 
{
	var padStr = "" + newNum;
	var padLen = origNumString.length - padStr.length;
	for (var i=0; i<padLen; i++) {
		padStr = "0" + padStr;
        }
	return padStr;
}

function nextplease_openLink (curWindow, linkNode)
{
    // If it's got an onclick attr, then try to 
    // simulate a mouse click to activate link.
    if (linkNode && linkNode.hasAttribute("onclick")) 
	{
	    // alert(linkNode.getAttribute("onclick"));
	    var e = document.createEvent("MouseEvents");
	    e.initMouseEvent("click", 1, 1, window, 1, 0,0,0,0,0,0,0,0,0,linkNode);
	    linkNode.dispatchEvent(e);
	}
    else
	{
	    curWindow.open(linkNode.href, "_self", "");
	}
    return true;
 }

// Look through all the HTML inputs for submit buttons
// that have a value that matches our phrases. If it
// finds a match, it submits the corresponding form
// (which will hopefully take us to the next/prev page).
function nextplease_getForm(phraseMap, phraseRegEx)
{
    var text;

    // Probably would be a little faster to
    // only check forms, but I'm getting problems
    // with them. I'm not sure if it's only on
    // malformed HTML pages, or if it's a Firefox bug.
    var inputs = window._content.document.getElementsByTagName("input");
	    
    for (var i=0; i<inputs.length; i++)	{
	if (inputs[i].type == 'submit') {
	    text = nextplease_Trim(inputs[i].value);
	    if (phraseMap[text] == true) {
		inputs[i].form.submit();
		return true;
	    } else {
		// If we don't have an exact match, 
		// try a quick regular expression test.
		if (phraseRegEx.test(text)) {
		    inputs[i].form.submit();
		    return true;
		}
	    } 
	}
    }
    return false;
}

// Looks through all the links and finds the link
// that matches the linkNum (an integer between
// 1 and 9). If it finds a match, it will go to 
// that link.
function nextplease_getNumberedLink(curWindow, linkNum) {
    var text;
    var isInt = /^\s*\[?\s*(\d+)\s*\]?\s*$/;
    var useFrames = true;

    nextplease_readPreferences();

    var alinks = curWindow.document.links;

    // Search through each link
    for(var i = alinks.length-1; i >= 0; i--) {
	var link = alinks[i];

	text = nextplease_Trim(link.text);
	
	var intMatches = isInt.exec(text);
	if (intMatches) {
	    var linkPageNum = parseInt(intMatches[1]);
	    if (linkPageNum == linkNum) {
		return nextplease_openLink(curWindow, link);
		//curWindow.open(link.href, "_self", "");
		//return true;
	    }
	}
    }

    var frames = curWindow.frames;
    for (var j=0; j < frames.length; j++) {
	if (nextplease_getNumberedLink(frames[j],linkNum))
	    return true;
    }    

    return false;
}

function nextplease_showHideMenuItems () {
    var menuitem;
    if (gContextMenu) {
	gContextMenu.showItem("nextplease_topMenu",useContextMenu);
	gContextMenu.showItem("nextPleasePopupMenu",useContextMenu);
	gContextMenu.showItem("prevPleasePopupMenu",useContextMenu);
	gContextMenu.showItem("firstPleasePopupMenu",useContextMenu);
	gContextMenu.showItem("lastPleasePopupMenu",useContextMenu);


	gContextMenu.showItem("nextPleaseAddPrevImage", 
			      useContextMenu && gContextMenu.onImage);
	gContextMenu.showItem("nextPleaseAddNextImage", 
			      useContextMenu && gContextMenu.onImage);
	gContextMenu.showItem("nextPleaseAddFirstImage", 
			      useContextMenu && gContextMenu.onImage);
	gContextMenu.showItem("nextPleaseAddLastImage", 
			      useContextMenu && gContextMenu.onImage);

	var showPhraseMenu = false;
	if (!gContextMenu.onImage && gContextMenu.onLink) {
	    showPhraseMenu = true;
	}
	gContextMenu.showItem("nextPleaseAddNextPhrase", 
			      useContextMenu && showPhraseMenu);
	gContextMenu.showItem("nextPleaseAddPrevPhrase", 
			      useContextMenu && showPhraseMenu);
	gContextMenu.showItem("nextPleaseAddFirstPhrase", 
			      useContextMenu && showPhraseMenu);
	gContextMenu.showItem("nextPleaseAddLastPhrase", 
			      useContextMenu && showPhraseMenu);

	gContextMenu.showItem("nextPleaseHideToolbar", true);

    }
}

function nextplease_addPhrase(map, prefname, defaultValues) {
    if (gContextMenu.onLink) {
	var range = document.createRange();
	range.selectNode(document.popupNode);
	var text = nextplease_Trim(range.toString());
	if (text != '') {
	    if ((map != NextPhrasesMap) && (NextPhrasesMap[text])) {
		alert('This phrase is already being used for Next.\n' +
		      'If you want, use the NextPlease! options page to remove it.');
	    } else if ((map != PrevPhrasesMap) && (PrevPhrasesMap[text])) {
		alert('This phrase is already being used for Prev.\n' +
		      'If you want, use the NextPlease! options page to remove it.');
	    } else if ((map != FirstPhrasesMap) && (FirstPhrasesMap[text])) {
		alert('This phrase is already being used for First.\n' +
		      'If you want, use the NextPlease! options page to remove it.');
	    } else if ((map != LastPhrasesMap) && (LastPhrasesMap[text])) {
		alert('This phrase is already being used for Last.\n' +
		      'If you want, use the NextPlease! options page to remove it.');
	    } else if (!map[text]) {
		map[text] = true;
		nextplease_addToPrefs(prefname, text, defaultValues);
	    }
	}
    }
}

function nextplease_addImage(map, prefname, defaultValues) {
    if (document.popupNode) {
	var imageurl = document.popupNode.src;
	if ((map != NextImagesMap) && (NextImagesMap[imageurl])) {
	    alert('This image is already being used for Next.\n' +
		  'If you want, use the NextPlease! options page to remove it.');
	} else if ((map != PrevImagesMap) && (PrevImagesMap[imageurl])) {
	    alert('This image is already being used for Prev.\n' +
		  'If you want, use the NextPlease! options page to remove it.');
	} else if ((map != FirstImagesMap) && (FirstImagesMap[imageurl])) {
	    alert('This image is already being used for First.\n' +
		  'If you want, use the NextPlease! options page to remove it.');
	} else if ((map != LastImagesMap) && (LastImagesMap[imageurl])) {
	    alert('This image is already being used for Last.\n' +
		  'If you want, use the NextPlease! options page to remove it.');
	} else if (!map[imageurl]) {
	    map[imageurl] = true;
	    nextplease_addToPrefs(prefname, imageurl, defaultValues);
	}
    }
}

function nextplease_addToPrefs(prefbranch, text, defaultValues) {
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var tempprefname = prefbranch + '.expr0';
    var prefvalue;
    if (nextpleasePrefs.prefHasUserValue(tempprefname)) {

	prefvalue = nextplease_GetUnicharPref(nextpleasePrefs, 
						  tempprefname);
    } else {
	prefvalue= "";
	for (var i=0; i<defaultValues.length; i++) {
	    prefvalue = prefvalue + "|" + defaultValues[i].replace(/\|/g, "&pipe;");
	}

    }
    text = prefvalue + "|" + text.replace(/\|/g, "&pipe;");
	
    nextplease_SetUnicharPref(nextpleasePrefs, tempprefname, text);
}

function nextplease_ToggleToolbar(){
    var toolbar = document.getElementById( "nextplease-toolbar" );

    if (toolbar) {
	goToggleToolbar('nextplease-toolbar');
    }
    setTimeout("document.getElementById('urlbar').focus()", 0);
}

window.addEventListener("load", function() { nextplease_init(); }, false);
window.addEventListener("popupshowing", nextplease_showHideMenuItems, false);
window.addEventListener("load",function(event){ nextpleaseLoadListener.onLoad(event); },false); 
